import 'package:diameter/main.dart';
import 'package:diameter/objectbox.g.dart';

@Entity()
class BasalProfile {
  static final Box<BasalProfile> box = objectBox.store.box<BasalProfile>();

  int id;
  String name;
  bool active;
  String? notes;

  BasalProfile({
    this.id = 0,
    this.name = '',
    this.active = false,
    this.notes,
  });

  static BasalProfile? get(int id) => box.get(id);
  static List<BasalProfile> getAll() => box.getAll();
  static void put(BasalProfile basalProfile) => box.put(basalProfile);
  static void remove(int id) => box.remove(id);

  static int activeCount() {
    Query<BasalProfile> query =
        box.query(BasalProfile_.active.equals(true)).build();
    return query.find().length;
  }

  static void setAllInactive() {
    box.putMany(box.getAll().map((element) {
      element.active = false;
      return element;
    }).toList());
  }
}
